#ifndef _LIBCVTEMPL_H_
#define _LIBCVTEMPL_H_

#include <opencv2/opencv.hpp>
#include <opencv2/gpu/gpu.hpp>

#include <string>

bool is_gpu_supported();

class Matcher {
  public:
   Matcher(unsigned int id, int method);
   ~Matcher() {}
   void load_template(std::string tmpl);
   void set_template(int height, int width, void *data);
   void match_template(int height, int width, void *data, int *loc_x, int *loc_y, double *value, bool *value_ok);
   void match_template_both_ways(int height, int width, void *data, int *loc_x, int *loc_y, double *value, bool *value_ok, bool *flipped);
  private:
   int m_method;
   cv::gpu::GpuMat m_tmpl_d, m_tmpl_dflip, m_result_d, m_image_d;
};


#endif
