import sys
import os.path

me = os.path.abspath(os.path.dirname(__file__))

sys.path.insert(0, os.path.abspath(os.path.join(me,'..','build','lib.linux-x86_64-2.7')))

import cv2
import numpy as np

import motmot.fview_head_track.cvtempl as cvtempl
print "CVTEMPL LOCATED\n\t", cvtempl.__file__

IMAGE = os.path.join(me,"testframe.png")
TEMPL = os.path.join(me,"fly2.png")
METH = cv2.TM_SQDIFF_NORMED

tmpl = cv2.imread(TEMPL, cv2.cv.CV_LOAD_IMAGE_GRAYSCALE)
img = cv2.imread(IMAGE, cv2.cv.CV_LOAD_IMAGE_GRAYSCALE)

print "image shape", img.shape, "height", img.shape[1]
print "templ shape", tmpl.shape, "height", tmpl.shape[0]

if cvtempl.is_available():
    print "GPU RESULT"
    m = cvtempl.GPUTemplateMatcher(method=METH)
    m.set_template(tmpl)

    for i in range(1000):
        loc = m.match_template_both_ways(img)
        if (i % 100) == 0:
            print "\t",loc
    print m.res
else:
    print "GPU SUPPORT NOT AVAILABLE"

print "CPU RESULT"
for i in range(1000):
    res = cv2.matchTemplate(img, tmpl, METH)
    min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(res)
    if METH == cv2.TM_SQDIFF_NORMED or METH == cv2.TM_SQDIFF:
        loc = min_loc
    else:
        loc = max_loc
    if (i % 100) == 0:
        print "\t",loc



